#property copyright "Oracle FX v1.2 (c) HotFx 2011.04.26"
#property link "http://hot-fx.blogspot.com" // http://hotfx.0pk.ru

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Gold
#property indicator_color3 Aqua

extern int  numbar      = 30; // max numbar = 199
extern bool Alternative = FALSE;

double cur[], pr1[], pr2[], tmp, mindiff, prvdiff, dl1, dl2, levels[200]; int i, j, sp1, sp2; datetime bt = 0;

void init()
 {
  SetIndexStyle(0, DRAW_LINE); SetIndexBuffer(0, cur);
  SetIndexStyle(1, DRAW_LINE); SetIndexBuffer(1, pr1);
  SetIndexStyle(2, DRAW_LINE); SetIndexBuffer(2, pr2);
  ObjectCreate("beg", OBJ_VLINE, 0, 0, 0);
  ObjectSet("beg", OBJPROP_COLOR, CornflowerBlue); ObjectSet("beg", OBJPROP_STYLE, STYLE_DOT);
  ObjectCreate("end", OBJ_VLINE, 0, 0, 0);
  ObjectSet("end", OBJPROP_COLOR, CornflowerBlue); ObjectSet("end", OBJPROP_STYLE, STYLE_DOT);
 }

void start()
 {
  if (bt == Time[1]) return;

  bt = Time[1]; mindiff = 999; prvdiff = 999; sp1 = 0; sp2 = 0;
  
  for (i = 1; i <= numbar; i++) levels[i] = Close[i] - Open[i];
  
  for (j = 1; j < (Bars - numbar); j++)
   {
    tmp = 0; for (i = 1; i <= numbar; i++) tmp = tmp + MathAbs(Close[j + i] - Open[j + i] - levels[i]);
    if (tmp < mindiff) { prvdiff = mindiff; mindiff = tmp; sp2 = sp1; sp1 = j; }
   }

  dl1 = Close[1] - Close[sp1 + 1]; dl2 = Close[1] - Close[sp2 + 1];

  for(i = 0; i < Bars; i++) { cur[i] = Close[i]; pr1[i] = Close[i] + dl1; if (Alternative) pr2[i] = Close[i] + dl2; }

  SetIndexShift(1, sp1); if (Alternative) SetIndexShift(2, sp2);
  
  ObjectSet("beg", OBJPROP_TIME1, Time[1]); ObjectSet("end", OBJPROP_TIME1, Time[numbar]);
 }

